/////////////////////////////////////////////////////////////////////////////////
//
// BkMail.h
//
// Copyright(C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: BkMail.h,v $
 * Revision 1.9  2000/07/20 05:10:48  syou
 * - PGP/MIME[̏،ʕ\@Aꂽp[gƓKw
 *   multipartƂĂ݂Bmulipart`ŕ̔폐p[g[
 *   ɂāȀЂƂЂƂ̌،ʂ\邱ƂlAUTF-8
 *   ISO-8859-1Ƃ[p[g؂ĂȂ1ނ̃GR[fB
 *   OXL[Ō،ʂ\ł悤ɂ邽߁BA[{̂
 *   Subjectŉ炩̃GR[hsĂƁAep[gContent-Typew
 *   QƂȂȂ錻ۂB2ibeta22jŌ󂯂Bǂ̂낤B
 *   Iɂ́Aɏ揼BkCommon.hABkCommon.cppɎĂ܂
 *   B揼񂪗t@C̃o[WAbvvĂȒPɒǏ]ł
 *   ͂Ȃ̂ǂACMIMEItemɗ~֐
 *   ł̂ƁAƂGetNameAndAddr()CMIMEItem::~CMIMEItem()̃
 *   [NACMIMEItemɑ΂ACMIMEItem::SetHeader()găwb_ݒ肵
 *   ĂƂɃANZXᔽN邱Ƃւ̑ΏȂǂs߁B
 *   񂩂A_CrtSetDbgFlag()giC}KW8Ƃ̂͂܂
 *   RƂĂj[NΏɂƂ߂B݂̂ƂAĂ
 *   Ń胊[N͑Ώς݁B
 *   APGPsdkUILibInit()ɂPGP UICȕDllMain()JɏW
 *   ȂǁB
 *
 * Revision 1.8  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 * Revision 1.7  2000/07/07 14:11:54  syou
 * - ؂Bmultipartȃ[؂ł܂BAʂ{ɕ\
 *   ̂Łccǂł傤H  Ƃ́A؃xwł悤ɂA
 *   ̑OɕȂẮB
 *   CBkMessage::ExploreItemTree̋@\͂܂ӖȂH
 *   CBkMailPGPn̎̂ł͂ȂāA͂class CBkPGPMailh
 *   čׂB
 *   class count_ptrǉČڕGBꂪƂĂȂ܂B
 *   قƂǐŁAclass CEventDataAclass CSignatureDataȂǂǉB
 *
 * Revision 1.3  2000/07/05 23:50:31  murayama-s
 * - ؂̎dg݂͂BƂ͏ڍׂȎdllȂ
 *    ȂBclass CSignatureDataǉB܂l̗]n傫
 *    classB
 *
 * Revision 1.6  2000/07/01 23:48:09  syou
 * - FindMIMEItemFirst()bugfix
 *
 * Revision 1.5  2000/06/29 15:23:35  syou
 * - class CBkMessageAclass CBkMailPartAclass CBkMail
 *   FindMIMEItemFirst()A FindMIMEItemNext()A ExploreItemTree()A
 *   IsMIMEItem()AȂǂȂǎBׂẮAPGPDecodevO
 *   邽߁BJavaCNnewIuWFNg߂悤
 *   ̂ŁAdeleteȂ΂ȂȂԂA
 *   Ȃ߃Ã΃ǃЃуŃʃł́Atemplate class count_ptr
 *   BA͏O̖{Ƃ肾̂Ȃ̂ŁAŐV
 *   ł͂ȂmȂBŔނWeby[WQƂKv邩
 *   ȁBDecoden̎͂ꂩȂ̂ŁA PGPsdk̃TvvO
 *   Ă (^^;  ܂܂ꂩ炾cc
 *
 * Revision 1.1.1.1  2000/05/20 16:41:00  syou
 * Ƃ肠An߂܂
 *
 */

#pragma once


#define CLASS_CBKMESSAGE


#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <mbstring.h>
#include <list>
#include "B2API.h"
#include "../BeckyAPI.h"
#include "../BkCommon.h"
#include "countptr.h"


#define WM_SET_TRANSFER_SAFE    WM_USER+300


/////////////////////////////////////////////////////////////////////////////////
//
class CBkMailPart;

typedef count_ptr<CBkMailPart>  CBkMailPartPtr;


/////////////////////////////////////////////////////////////////////////////////
//
/**
 * CBkMessage::FindMIMEItemFirst
 */
#define FINDMIMEITEM_CHILD                  0x00000001
#define FINDMIMEITEM_NEXT                   0x00000002
#define FINDMIMEITEM_FIRST_ONE              0x00000004
#define FINDMIMEITEM_SECOND_ONE             0x00000008
#define FINDMIMEITEM_FIRST_SOME             0x00000010
#define FINDMIMEITEM_SECOND_SOME            0x00000020
#define FINDMIMEITEM_FIRST_CHILD            0x00000041
#define FINDMIMEITEM_FIRST_NEXT             0x00000082

#define FINDMIMEITEM_DEFAULT                FINDMIMEITEM_CHILD | \
                                            FINDMIMEITEM_NEXT | \
                                            FINDMIMEITEM_FIRST_CHILD | \
                                            FINDMIMEITEM_FIRST_SOME | \
                                            FINDMIMEITEM_SECOND_SOME

#define FINDMIMEITEM_UNDER_STAGE            FINDMIMEITEM_CHILD   | \
                                            FINDMIMEITEM_NEXT | \
                                            FINDMIMEITEM_FIRST_CHILD   | \
                                            FINDMIMEITEM_FIRST_ONE | \
                                            FINDMIMEITEM_SECOND_SOME


/////////////////////////////////////////////////////////////////////////////////
//
class CBkMessage
{
public:
    CBkMessage();
    CBkMessage(const CBkMessage& bm);
    virtual ~CBkMessage();
    virtual CBkMessage& operator=(const CBkMessage& bm);

    //virtual BOOL SetText(int nMode, LPCTSTR lpszText) = 0;
    //virtual void GetCharSet(LPSTR lpszCharSet, int nBuf) const = 0;
    virtual void GetHeader(LPCTSTR lpHeader, LPSTR lpszBuf, int nBuf) = 0;
    virtual void SetHeader(LPCTSTR lpHeader, LPCTSTR lpData) = 0;
    virtual CBkMailPart* SetChild(CMIMEItem* pChild) = 0;
    virtual CBkMailPart* AddChild(CMIMEItem* pChild) = 0;
    virtual CBkMailPart* SetNext(CMIMEItem* pNext) = 0;
    virtual void ListHeadersEmpty() = 0;
    virtual void ListHeadersAddFront(LPSTR lpLine) = 0;
    virtual void ListHeadersAddTail(LPSTR lpLine) = 0;
    virtual void ListBodyEmpty() = 0;
    virtual void ListBodyAddFront(LPSTR lpLine) = 0;
    virtual void ListBodyAddTail(LPSTR lpLine) = 0;
    virtual void ListTrailEmpty() = 0;
    virtual void ListTrailAddFront(LPSTR lpLine) = 0;
    virtual void ListTrailAddTail(LPSTR lpLine) = 0;
    virtual BOOL IsMIMEItem(LPCTSTR lpszType, LPCTSTR lpszSubType) = 0;
    virtual CBkMailPart* FindMIMEItemFirst(LPCTSTR lpszType, LPCTSTR lpszSubType, DWORD dwFlag) = 0;
    virtual CBkMailPart* FindMIMEItemNext() = 0;
    virtual CBkMailPart* GetChild() = 0;
    virtual CBkMailPart* GetNext() = 0;
    virtual const char* GetMIMEType() = 0;
    virtual const char* GetMIMESubType() = 0;
    virtual const char* GetMIMEBoundary() = 0;
    virtual LPSTR GetPGPOriginalText(BOOL bPGPMIME) = 0;
    virtual void NotifyChanged() = 0;
    virtual LPSTR ToString();
    virtual void FromString(LPSTR& lpszSrc, LPCTSTR lpBoundary=NULL);


protected:
    virtual void SetContentType(LPCTSTR lpHeader, LPCTSTR lpData);
    virtual void ExploreItemTree(LPCTSTR lpszType, LPCTSTR lpszSubType, CMIMEItem* pItem, DWORD dwFlag);

    CB2API* m_pbka;
    CMIMEItem* m_pItem;
    std::list<CMIMEItem*> m_listItem;

private:
};


/////////////////////////////////////////////////////////////////////////////////
//
inline LPSTR CBkMessage::ToString()
{
    return m_pItem->ToString();
}


inline void CBkMessage::FromString(LPSTR& lpszSrc, LPCTSTR lpBoundary)
{
    m_pItem->FromString(lpszSrc, lpBoundary);
}


/////////////////////////////////////////////////////////////////////////////////
//
class CBkMailPart : public CBkMessage
{
public:
    // CBkMailPart
    CBkMailPart(const CBkMailPart& bmp);
    CBkMailPart(CBkMessage* pbmParent, CMIMEItem* pItem);
    virtual ~CBkMailPart() {}
    CBkMailPart& operator=(const CBkMailPart& bmp);

    // CBkMessage
    void GetHeader(LPCTSTR lpHeader, LPSTR lpszBuf, int nBuf);
    void SetHeader(LPCTSTR lpHeader, LPCTSTR lpData);
    CBkMailPart* SetChild(CMIMEItem* pChild);
    CBkMailPart* AddChild(CMIMEItem* pChild);
    CBkMailPart* SetNext(CMIMEItem* pNext);
    void ListHeadersEmpty();
    void ListHeadersAddFront(LPSTR lpLine);
    void ListHeadersAddTail(LPSTR lpLine);
    void ListBodyEmpty();
    void ListBodyAddFront(LPSTR lpLine);
    void ListBodyAddTail(LPSTR lpLine);
    void ListTrailEmpty();
    void ListTrailAddFront(LPSTR lpLine);
    void ListTrailAddTail(LPSTR lpLine);
    BOOL IsMIMEItem(LPCTSTR lpszType, LPCTSTR lpszSubType);
    CBkMailPart* FindMIMEItemFirst(LPCTSTR lpszType, LPCTSTR lpszSubType, DWORD dwFlag);
    CBkMailPart* FindMIMEItemNext();
    CBkMailPart* GetChild();
    CBkMailPart* GetNext();
    const char* GetMIMEType();
    const char* GetMIMESubType();
    const char* GetMIMEBoundary();
    void NotifyChanged();

    // CBkMailPart
    CBkMessage* GetParent() const;
    LPSTR GetPGPOriginalText(BOOL bPGPMIME);


protected:

private:
    CBkMessage* m_pbmParent;
    std::list<CMIMEItem*>::iterator m_iMimeItem;
};


/////////////////////////////////////////////////////////////////////////////////
//

inline void CBkMailPart::GetHeader(LPCTSTR lpHeader, LPSTR lpszBuf, int nBuf)
{
    m_pItem->GetHeader(lpHeader, lpszBuf, nBuf);
}


inline void CBkMailPart::SetHeader(LPCTSTR lpHeader, LPCTSTR lpData)
{
    if (strnicmp(lpHeader, "Content-Type", 12) == 0) {
        SetContentType(lpHeader, lpData);
    }
    m_pItem->SetHeader(lpHeader, lpData);
}


inline void CBkMailPart::ListHeadersEmpty()
{
    m_pItem->m_lstHeaders.Empty();
    NotifyChanged();
}


inline void CBkMailPart::ListHeadersAddFront(LPSTR lpLine)
{
    CPointerItem* pTop = m_pItem->m_lstHeaders.GetTop();
    if (pTop) {
        m_pItem->m_lstHeaders.InsertBefore(pTop, lpLine);
    }
    else {
        m_pItem->m_lstHeaders.AddTail(lpLine);
    }
    NotifyChanged();
}


inline void CBkMailPart::ListHeadersAddTail(LPSTR lpLine)
{
    m_pItem->m_lstHeaders.AddTail(lpLine);
    NotifyChanged();
}


inline void CBkMailPart::ListBodyEmpty()
{
    m_pItem->m_lstBody.Empty();
    NotifyChanged();
}


inline void CBkMailPart::ListBodyAddFront(LPSTR lpLine)
{
    CPointerItem* pTop = m_pItem->m_lstBody.GetTop();
    if (pTop) {
        m_pItem->m_lstBody.InsertBefore(pTop, lpLine);
    }
    else {
        m_pItem->m_lstBody.AddTail(lpLine);
    }
    NotifyChanged();
}


inline void CBkMailPart::ListBodyAddTail(LPSTR lpLine)
{
    m_pItem->m_lstBody.AddTail(lpLine);
    NotifyChanged();
}


inline void CBkMailPart::ListTrailEmpty()
{
    m_pItem->m_lstTrail.Empty();
    NotifyChanged();
}


inline void CBkMailPart::ListTrailAddFront(LPSTR lpLine)
{
    CPointerItem* pTop = m_pItem->m_lstTrail.GetTop();
    if (pTop) {
        m_pItem->m_lstTrail.InsertBefore(pTop, lpLine);
    }
    else {
        m_pItem->m_lstTrail.AddTail(lpLine);
    }
    NotifyChanged();
}


inline void CBkMailPart::ListTrailAddTail(LPSTR lpLine)
{
    m_pItem->m_lstTrail.AddTail(lpLine);
    NotifyChanged();
}


inline CBkMailPart* CBkMailPart::GetChild()
{
    CMIMEItem* pItem = m_pItem->GetChild();
    if (pItem == NULL) {
        return NULL;
    }
    return new CBkMailPart(m_pbmParent, pItem);
}


inline CBkMailPart* CBkMailPart::GetNext()
{
    CMIMEItem* pItem = m_pItem->GetNext();
    if (pItem == NULL) {
        return NULL;
    }
    return new CBkMailPart(m_pbmParent, pItem);
}


inline const char* CBkMailPart::GetMIMEType()
{
    return m_pItem->m_szType;
}


inline const char* CBkMailPart::GetMIMESubType()
{
    return m_pItem->m_szSubType;
}


inline const char* CBkMailPart::GetMIMEBoundary()
{
    return m_pItem->m_lpBoundary;
}


inline void CBkMailPart::NotifyChanged()
{
    if (m_pbmParent) {
        m_pbmParent->NotifyChanged();
    }
}


// CBkMailPart
inline CBkMessage* CBkMailPart::GetParent() const
{
    return m_pbmParent;
}


/////////////////////////////////////////////////////////////////////////////////
//
class CBkMail : public CBkMessage
{
public:
    // CBkMail
    CBkMail(const CBkMail& bm);
    virtual ~CBkMail();
    CBkMail& operator=(const CBkMail& bm);

    // CBkMessage
    LPCTSTR GetSource();
    //void DeleteItem(CMIMEItem* pItem);
    void GetHeader(LPCTSTR lpHeader, LPSTR lpszBuf, int nBuf);
    void SetHeader(LPCTSTR lpHeader, LPCTSTR lpData);
    CBkMailPart* SetChild(CMIMEItem* pChild);
    CBkMailPart* AddChild(CMIMEItem* pChild);
    CBkMailPart* SetNext(CMIMEItem* pNext);
    void ListHeadersEmpty();
    void ListHeadersAddFront(LPSTR lpLine);
    void ListHeadersAddTail(LPSTR lpLine);
    void ListBodyEmpty();
    void ListBodyAddFront(LPSTR lpLine);
    void ListBodyAddTail(LPSTR lpLine);
    void ListTrailEmpty();
    void ListTrailAddFront(LPSTR lpLine);
    void ListTrailAddTail(LPSTR lpLine);
    BOOL IsMIMEItem(LPCTSTR lpszType, LPCTSTR lpszSubType);
    CBkMailPart* FindMIMEItemFirst(LPCTSTR lpszType, LPCTSTR lpszSubType, DWORD dwFlag);
    CBkMailPart* FindMIMEItemNext();
    CBkMailPart* GetChild();
    CBkMailPart* GetNext();
    const char* GetMIMEType();
    const char* GetMIMESubType();
    const char* GetMIMEBoundary();
    void NotifyChanged();

    // CBkMail
    explicit CBkMail(HWND hWnd);
    explicit CBkMail(LPCTSTR lpMailID);
    BOOL Commit();
    void ReloadSource();
    BOOL SetText(int nMode, LPCTSTR lpszText);
    void GetCharSet(LPSTR lpszCharSet, int nBuf) const;

    LPSTR GetPGPOriginalText(BOOL bPGPMIME);

protected:
    // CBkMessage
    LPCTSTR GetContent();

    // CBkMail
    LPSTR GetText() const;
    inline void LoadSource();

    CPointerList m_lstItems;

private:
    HWND m_hWnd;
    LPSTR m_lpSource;
    LPSTR m_lpMailID;
    BOOL m_bChanged;
    std::list<CMIMEItem*>::iterator m_iMimeItem;
};


/////////////////////////////////////////////////////////////////////////////////
//

inline LPCTSTR CBkMail::GetSource()
{
    LoadSource();
    return m_lpSource;
}


inline void CBkMail::GetHeader(LPCTSTR lpHeader, LPSTR lpszBuf, int nBuf)
{
    if (m_lpSource) {
        m_pItem->GetHeader(lpHeader, lpszBuf, nBuf);
        return;
    }

    if (m_hWnd) {
        m_pbka->CompGetSpecifiedHeader(m_hWnd, lpHeader, lpszBuf, nBuf);
    }
    else {
        m_pbka->SetCurrentMail(m_lpMailID);
        m_pbka->GetSpecifiedHeader(lpHeader, lpszBuf, nBuf);
    }
}


inline void CBkMail::SetHeader(LPCTSTR lpHeader, LPCTSTR lpData)
{
    LoadSource();
    if (strnicmp(lpHeader, "Content-Type:", 13) == 0) {
        SetContentType(lpHeader, lpData);
    }
    m_pItem->SetHeader(lpHeader, lpData);
}


inline void CBkMail::ListHeadersEmpty()
{
    LoadSource();
    m_pItem->m_lstHeaders.Empty();
    NotifyChanged();
}


inline void CBkMail::ListHeadersAddFront(LPSTR lpLine)
{
    LoadSource();
    CPointerItem* pTop = m_pItem->m_lstHeaders.GetTop();
    if (pTop) {
        m_pItem->m_lstHeaders.InsertBefore(pTop, lpLine);
    }
    else {
        m_pItem->m_lstHeaders.AddTail(lpLine);
    }
    NotifyChanged();
}


inline void CBkMail::ListHeadersAddTail(LPSTR lpLine)
{
    LoadSource();
    m_pItem->m_lstHeaders.AddTail(lpLine);
    NotifyChanged();
}


inline void CBkMail::ListBodyEmpty()
{
    LoadSource();
    m_pItem->m_lstBody.Empty();
    NotifyChanged();
}


inline void CBkMail::ListBodyAddFront(LPSTR lpLine)
{
    LoadSource();
    CPointerItem* pTop = m_pItem->m_lstBody.GetTop();
    if (pTop) {
        m_pItem->m_lstBody.InsertBefore(pTop, lpLine);
    }
    else {
        m_pItem->m_lstBody.AddTail(lpLine);
    }
    NotifyChanged();
}


inline void CBkMail::ListBodyAddTail(LPSTR lpLine)
{
    LoadSource();
    m_pItem->m_lstBody.AddTail(lpLine);
    NotifyChanged();
}


inline void CBkMail::ListTrailEmpty()
{
    LoadSource();
    m_pItem->m_lstTrail.Empty();
    NotifyChanged();
}


inline void CBkMail::ListTrailAddFront(LPSTR lpLine)
{
    LoadSource();
    CPointerItem* pTop = m_pItem->m_lstTrail.GetTop();
    if (pTop) {
        m_pItem->m_lstTrail.InsertBefore(pTop, lpLine);
    }
    else {
        m_pItem->m_lstTrail.AddTail(lpLine);
    }
    NotifyChanged();
}


inline void CBkMail::ListTrailAddTail(LPSTR lpLine)
{
    LoadSource();
    m_pItem->m_lstTrail.AddTail(lpLine);
    NotifyChanged();
}


inline CBkMailPart* CBkMail::GetChild()
{
    CMIMEItem* pItem = m_pItem->GetChild();
    if (pItem == NULL) {
        return NULL;
    }
    return new CBkMailPart(this, pItem);
}


inline CBkMailPart* CBkMail::GetNext()
{
    CMIMEItem* pItem = m_pItem->GetNext();
    if (pItem == NULL) {
        return NULL;
    }
    return new CBkMailPart(this, pItem);
}


inline const char* CBkMail::GetMIMEType()
{
    return m_pItem->m_szType;
}


inline const char* CBkMail::GetMIMESubType()
{
    return m_pItem->m_szSubType;
}


inline const char* CBkMail::GetMIMEBoundary()
{
    return m_pItem->m_lpBoundary;
}


inline void CBkMail::NotifyChanged()
{
    m_bChanged = TRUE;
}


inline void CBkMail::LoadSource()
{
    if (m_lpSource == NULL) {
        ReloadSource();
    }
}
